/*------------------------------------------------------------------------------------------------
Author     : Rey Ocampo
Company    : Husky Energy
Description: Manages global actions of Service Notification Request
Inputs     : N/A
Test Class : ServiceNotificationRequestGlobalTest
History    : 10.06.15   rbo Modifications to createNoticationOrderInSAP for SNR and DEFT
                            Added createServiceRigWorkOrder() for Service Rig Program
                            Tech Debt Fixes
            01.08.16    rbo Modifications due to Refactoring
                            replaced all HOG_Rigless_Servicing_Form__c with HOG_Maintenance_Servicing_Form__c
                            modified reference to Notification Type to come directly from the Notification Type Master
                                by replacing 
                                HOG_Service_Request_Notification_Form__r.HOG_Work_Order_Type__r.HOG_Notification_Type__r
                                to HOG_Notification_Type__r
            31.07.17    mz - updated updateNotificationOrderFromSAP for System, Sub-System & Well Event 
            31.08.17    mb - update updateNotificationOrderFromSAP for Yard and FEL          
------------------------------------------------------------------------------------------------------------------------*/ 
global with sharing class ServiceNotificationRequestGlobal
{           
   /**************************************************************************************************
    * Returns the URL of the Task for the Recurring services
    * serviceRequestId - The id of the Service Notification Request
    **************************************************************************************************/
    public static String isTestRespType; 
    
    webservice static String readURLRecurringService(ID serviceRequestId)
    {       
        System.debug('\n**********************************************************\n'
            + 'METHOD: ServiceNotificationRequestGlobal.readURLRecurringService()'
            + '\nserviceRequestId: ' + serviceRequestId
            + '\n*****************************************************************\n');
        
        List<Task> taskRecord =        
            [Select
                Id
            From Task
            Where IsClosed = false 
            And ActivityDate = null
            And What.Type ='HOG_Service_Request_Notification_Form__c' 
            And WhatId = :serviceRequestId Order By Id Limit 1];

        if (taskRecord.isEmpty())
            return '';                
        else
            return '/' + taskRecord[0].Id + '/e?retURL=%2F' + serviceRequestId;
    }


   /**************************************************************************************************
    * Cancels all recurring services and returns the number of cancelled Recurring services
    * serviceRequestId - The id of the Service Notification Request
    **************************************************************************************************/    
    webservice static Integer cancelScheduledRecurringService(ID serviceRequestId)
    {
        System.debug('\n******************************************************************\n'
            + 'METHOD: ServiceNotificationRequestGlobal.cancelScheduledRecurringService()'
            + '\nserviceRequestId: ' + serviceRequestId
            + '\n*************************************************************************\n');
   
        Integer cancelledTask = 0;
   
        // put the record id into a set and get the associated service request records
        Set<Id> setIds = new Set<Id>{serviceRequestId};             
        
        // this will return 1 record or none 
        List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord = ServiceRequestNotificationUtilities.readServiceNotificationRequests(setIds);
    
        if (!serviceRequestFormRecord.isEmpty())
        {           
            if (serviceRequestFormRecord[0].UserRecordAccess.HasEditAccess)
            {
                List<Task> taskRecurringRecord =
                    [Select
                        Id
                    From Task
                    Where IsRecurrence = true
                    And WhatId = :serviceRequestId
                    And What.Type ='HOG_Service_Request_Notification_Form__c'];
        
                cancelledTask = taskRecurringRecord.size();
                
                if (cancelledTask > 0)
                {
                    Savepoint savePoint = Database.setSavepoint();
                                                
                    try
                    {                                    
                        delete taskRecurringRecord;
            
                        System.debug('\n***************************************\n'
                            + 'METHOD: cancel recurring'
                            + '\ndeleted records: ' + cancelledTask
                            + '\n**********************************************\n');
                    }
                    catch (System.DmlException e) 
                    {
                        cancelledTask = 0;
                        
                        Database.rollback(savePoint);
        
                        System.debug('\n***************************************\n'
                            + 'METHOD: ServiceNotificationRequestGlobal.cancelScheduledRecurringService()');
        
                        for (Integer i = 0; i < e.getNumDml(); i++) 
                            System.debug('\n' + e.getDmlMessage(i));    
                    }                                                                                    
                }
            }
        }
            
        return cancelledTask;
    }        


   /******************************************************************************************************************************
    * Updates the work order number and returns the updated work order number or an error message
    *    calls "SAP Update WO" if notification type service is configured to SAP generate number (Generate_Numbers_From_SAP__c)
    * wellServicingFormId - The id of the Well Servicing Work Order record
    * notificationServicingFormId - The id of the Service Notification Request record 
    * workOrderNumber - The work order number
    ******************************************************************************************************************************/    
    webservice static String updateWorkOrderNumber(Id wellServicingFormId, Id notificationServicingFormId, String workOrderNumber)
    {
        System.debug('\n********************************************************\n'
            + 'METHOD: ServiceNotificationRequestGlobal.updateWorkOrderNumber()'
            + '\nwellServicingFormId: ' + wellServicingFormId
            + '\nnotificationServicingFormId: ' + notificationServicingFormId
            + '\nworkOrderNumber: ' + workOrderNumber
            + '\n***************************************************************\n');

        Integer updatedWellServicingFormRecord = 0;
        String returnMessage = 'You are not allowed to update the work order number!';

        // this will return 1 record or none         
        List<HOG_Maintenance_Servicing_Form__c> wellServicingFormRecord = readServiceWorkOrders(wellServicingFormId);
        
        if (!wellServicingFormRecord.isEmpty())
        {           
            if (wellServicingFormRecord[0].TECO__c || wellServicingFormRecord[0].Service_Status__c == 'Complete' || wellServicingFormRecord[0].Service_Status__c == 'Cancelled')
                returnMessage = 'Work order status is already set to one of the following "TECO, Complete, Cancelled". Unable to update the work order number!';                
            else
            {               
                if (wellServicingFormRecord[0].HOG_Notification_Type__r.Allow_Manual_Update_Of_Work_Order_Number__c)
                {
                    if ((wellServicingFormRecord[0].HOG_Notification_Type__r.Generate_Numbers_From_SAP__c && 
                    wellServicingFormRecord[0].SAP_Request_Returned_Critical_Error__c) ||
                    !wellServicingFormRecord[0].HOG_Notification_Type__r.Generate_Numbers_From_SAP__c) 
                    {           
                        if (wellServicingFormRecord[0].Recurring__c)  // do not update SNR
                            returnMessage = 
                                wellServicingFormRecord[0].HOG_Notification_Type__r.Generate_Numbers_From_SAP__c
                                ? updateServiceWorkOrderFromSAP(wellServicingFormId, notificationServicingFormId, workOrderNumber)
                                : updateWorkOrderRecord(wellServicingFormRecord, workOrderNumber);
                        else // update SNR
                        {
                            List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord =
                                [Select
                                    Id,
                                    Work_Order_Number__c
                                From HOG_Service_Request_Notification_Form__c
                                Where Id = :notificationServicingFormId];
                                                
                            if (serviceRequestFormRecord.isEmpty())
                            {
                                returnMessage = 'Service Request Notification does not exist. Unable to update the work order number!';
                            }
                            else
                            {
                                serviceRequestFormRecord[0].Work_Order_Number__c = workOrderNumber;
                                
                                returnMessage = 
                                    wellServicingFormRecord[0].HOG_Notification_Type__r.Generate_Numbers_From_SAP__c
                                    ? updateServiceWorkOrderFromSAP(wellServicingFormId, notificationServicingFormId, workOrderNumber)
                                    : updateWorkOrderRecord(wellServicingFormRecord, serviceRequestFormRecord, workOrderNumber);
                            }
                        }
                    }
                }                                   
            }
        }
           
        return returnMessage;
    }
    
    
   /*******************************************************************************************************************************
    * Updates the well servicing record and service notification request, returns the updated work order number or an error message
    * wellServicingFormRecord - The Well Servicing Work Order record to be updated
    * serviceRequestFormRecord - The Service Notification Request record to be updated
    * workOrderNumber - The work order number
    *******************************************************************************************************************************/
    @TestVisible        
    private static String updateWorkOrderRecord
    (
        List<HOG_Maintenance_Servicing_Form__c> wellServicingFormRecord, 
        List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord, 
        String workOrderNumber 
    )
    {
        Integer updatedWellServicingFormRecord = 0;
        String returnMessage = 'You are not allowed to update the work order number!';
                                
        String workOrderName;
                                            
        for (HOG_Maintenance_Servicing_Form__c record : wellServicingFormRecord)
        {
            workOrderName = record.Facility__r.Name == null ? record.Location__r.Name : record.Facility__r.Name;            
            record.Work_Order_Number__c = workOrderNumber;
            record.Name = workOrderName + ' - ' + workOrderNumber;
            updatedWellServicingFormRecord++;
        }
        
        if (updatedWellServicingFormRecord > 0)
        {
            ServiceRequestNotificationUtilities.executeTriggerCode = false;
            WellServicingUtilities.executeTriggerCode = false;
            MaintenanceServicingUtilities.executeTriggerCode = false;
            
            Savepoint savePoint = Database.setSavepoint();
    
            try 
            {
                update wellServicingFormRecord;        
                update serviceRequestFormRecord;
                returnMessage = workOrderNumber;
            }
            catch (System.DmlException e) 
            {                
                Database.rollback(savePoint);
    
                System.debug('\n********************************************************\n'
                    + 'METHOD: ServiceNotificationRequestGlobal.updateWorkOrderRecord()'
                    + '\n***************************************************************\n');
    
                for (Integer i = 0; i < e.getNumDml(); i++)
                    returnMessage = returnMessage + '\n' + e.getDmlMessage(i);
                
                System.debug(returnMessage);                    
            }                                                                                    
        }
                
        return returnMessage;
    }
    

   /*************************************************************************************************
    * Updates the well servicing record and returns the updated work order number or an error message
    * wellServicingFormRecord - The Well Servicing Work Order record to be updated
    * workOrderNumber - The work order number
    *************************************************************************************************/ 
    @TestVisible               
    private static String updateWorkOrderRecord
    (
        List<HOG_Maintenance_Servicing_Form__c> wellServicingFormRecord, 
        String workOrderNumber 
    )
    {
        Integer updatedWellServicingFormRecord = 0;
        String returnMessage = 'You are not allowed to update the work order number!';                               
        String workOrderName;
                                            
        for (HOG_Maintenance_Servicing_Form__c record : wellServicingFormRecord)
        {
            workOrderName = record.Facility__r.Name == null ? record.Location__r.Name : record.Facility__r.Name;            
            record.Work_Order_Number__c = workOrderNumber;
            record.Name = 
                workOrderNumber == null
                ? workOrderName + ' - Pending Work Order' 
                : workOrderName + ' - ' + workOrderNumber;
            
            updatedWellServicingFormRecord++;
        }
        
        if (updatedWellServicingFormRecord > 0)
        {
            ServiceRequestNotificationUtilities.executeTriggerCode = false;
            WellServicingUtilities.executeTriggerCode = false;
            MaintenanceServicingUtilities.executeTriggerCode = false;

            Savepoint savePoint = Database.setSavepoint();
    
            try 
            {
                update wellServicingFormRecord;        
                returnMessage = workOrderNumber;
            }
            catch (System.DmlException e) 
            {                
                Database.rollback(savePoint);
    
                System.debug('\n********************************************************\n'
                    + 'METHOD: ServiceNotificationRequestGlobal.updateWorkOrderRecord()'
                    + '\n***************************************************************\n');
    
                for (Integer i = 0; i < e.getNumDml(); i++)
                    returnMessage = returnMessage + '\n' + e.getDmlMessage(i);
                
                System.debug(returnMessage);                    
            }                                                                                    
        }
                
        return returnMessage;
    }


   /*********************************************************************************************************************
    * Calls the SAP Single Create WO web service, updates the work order, and returns an empty string or an error message
    * wellServicingFormId - The id of the well servicing work order record
    * notificationServicingFormId - The id of the service notification request record
    *********************************************************************************************************************/    
    webservice static String createServiceWorkOrderInSAP(Id wellServicingFormId, Id notificationServicingFormId)
    {
        System.debug('\n**************************************************************\n'
            + 'METHOD: ServiceNotificationRequestGlobal.createServiceWorkOrderInSAP()'
            + '\nwellServicingFormId: ' + wellServicingFormId
            + '\nnotificationServicingFormId: ' + notificationServicingFormId
            + '\n*********************************************************************\n');

        String returnMessage = 'Service is down, please try again later...';
        
        // this will return 1 record or none 
        List<HOG_Maintenance_Servicing_Form__c> wellServicingFormRecord = readServiceWorkOrders(wellServicingFormId);
                
        if (!wellServicingFormRecord.isEmpty())
        {                   
            // put the record id into a set and get the associated service request records
            Set<Id> setIds = new Set<Id>{notificationServicingFormId};
            
            // this will return 1 record or none 
            List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord = ServiceRequestNotificationUtilities.readServiceNotificationRequests(setIds);
                                
            If (!serviceRequestFormRecord.isEmpty())
            {
                HOG_Settings__c settingsHOG = HOG_Settings__c.getInstance();

                String functionalLocationObjectId = serviceRequestFormRecord[0].SAP_Object_ID__c;                   
                String maintenancePlanningPlant = serviceRequestFormRecord[0].Maintenance_Plant__c;
                String mainWorkCentre = serviceRequestFormRecord[0].Main_Work_Centre__c;                                                                    
                                
                Integer lengthDescription = 
                    String.IsBlank(wellServicingFormRecord[0].Work_Details__c)
                    ? 0
                    : wellServicingFormRecord[0].Work_Details__c.length();
                                        
                String mainDescription = 
                    String.IsBlank(wellServicingFormRecord[0].Work_Details__c) 
                    ? '' 
                    : wellServicingFormRecord[0].Work_Details__c.substring
                        (0, lengthDescription < ServiceRequestNotificationUtilities.LENGTHSAPMAINDESC 
                            ? lengthDescription : ServiceRequestNotificationUtilities.LENGTHSAPMAINDESC);
                
                String mainLongDescription = wellServicingFormRecord[0].Work_Details__c;                        
                                       
                String priority = serviceRequestFormRecord[0].HOG_Notification_Type_Priority_WO__r.Priority_Code__c;
                String notificationOrderTypeCode = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.Order_Type__c;
                String notificationUserStatusCode = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.HOG_User_Status__r.Code__c;               
                String maintenanceActivityType = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.MAT_Code__c;
                String equipmentNumber = wellServicingFormRecord[0].Equipment__r.Equipment_Number__c;
                                
                SAPHOGWorkOrderServices.WorkOrderPort workOrder = new SAPHOGWorkOrderServices.WorkOrderPort();
                SAPHOGWorkOrderServices.CreateWorkOrderResponse response = new SAPHOGWorkOrderServices.CreateWorkOrderResponse();
    
                try
                {
                    if (Test.isRunningTest())
                    {
                        response.type_x = True;
                        response.WorkOrder = new SAPHOGWorkOrderServices.WorkOrder();
                    }
                    else
                        response = 
                            workOrder.CreateWorkOrder
                            (
                                 functionalLocationObjectId, 
                                 maintenancePlanningPlant,
                                 mainDescription,
                                 mainLongDescription,
                                 priority,
                                 notificationOrderTypeCode,
                                 mainWorkCentre,  //settingsHOG.SAP_Create_Work_Order_WSR_Work_Centre__c,
                                 maintenanceActivityType,
                                 settingsHOG.SAP_Create_Work_Order_Activity_Code__c,
                                 settingsHOG.SAP_Create_Work_Order_Control_Key__c,
                                 notificationUserStatusCode,
                                 wellServicingFormRecord[0].Notification_Number__c,
                                 null,
                                 equipmentNumber
                            );
                }
                catch(Exception e)
                {
                    response = null;                                
                    System.debug('An unexpected error has occurred: ' + e.getMessage());
                    returnMessage = 'Service is not available because of the following error: ' + e.getMessage();
                }           
                
                if (response != null)
                {                                                                                                                                  
                    if (response.type_x)
                    {
                        wellServicingFormRecord[0].SAP_Changed_Date__c =  response.WorkOrder.ChangedDate;
                        wellServicingFormRecord[0].SAP_Changed_By__c = response.WorkOrder.ChangedBy;
                        wellServicingFormRecord[0].System_Status_Code__c = response.WorkOrder.SystemStatus;
                        wellServicingFormRecord[0].User_Status_Code__c = response.WorkOrder.UserStatus;
                        wellServicingFormRecord[0].Work_Details_Short__c = mainDescription;
                        wellServicingFormRecord[0].Request_Generate_Number_Message__c = null;
                        wellServicingFormRecord[0].SAP_Generated_Work_Order_Number__c = true;

                        if (wellServicingFormRecord[0].Recurring__c)  // do not update SNR, work order number for SNR and Well Servicing WO may be different
                            returnMessage = updateWorkOrderRecord(wellServicingFormRecord, response.WorkOrder.WorkOrderNumber);
                        else  // update SNR, work order number for SNR and Well Servicing WO is expected to be the same
                        {   
                            serviceRequestFormRecord[0].Work_Order_Number__c = response.WorkOrder.WorkOrderNumber;
                            serviceRequestFormRecord[0].SAP_Generated_Work_Order_Number__c = true;
                            returnMessage = updateWorkOrderRecord(wellServicingFormRecord, serviceRequestFormRecord, response.WorkOrder.WorkOrderNumber);
                        }
                        
                        returnMessage = returnMessage != response.WorkOrder.WorkOrderNumber ? returnMessage : '';
                    }
                    else
                        returnMessage = response.Message;                                       
                }           
            }
            else
                returnMessage = 'Service Request Notification does not exist. Unable to update the work order number!';
        }
        else
            returnMessage = 'Work Order record does not exist. Unable to update the work order number!';                        
        
        return returnMessage;
    }


   /*********************************************************************************************************************************************
    * Calls the SAP Single Create WO web service, create Rig Program work order, and returns an empty string or an error message
    * serviceRigProgramId - The id of the rig program record
    * notificationServicingFormId - The id of the service notification request record
    ********************************************************************************************************************************************/    
    webservice static String createServiceRigWorkOrder(Id serviceRigProgramId, Id notificationServicingFormId, Id serviceRigProgramRecordTypeId)
    {
        System.debug('\n**************************************************************\n'
            + 'METHOD: ServiceNotificationRequestGlobal.createServiceRigWorkOrder()'
            + '\nserviceRigProgramId: ' + serviceRigProgramId
            + '\nnotificationServicingFormId: ' + notificationServicingFormId
            + '\nserviceRigProgramRecordTypeId: ' + serviceRigProgramRecordTypeId
            + '\n*********************************************************************\n');

        String returnMessage = 'Service is down, please try again later...';
        
        // this will return 1 record or none 
        List<HOG_Service_Rig_Program__c> rigProgramRecord = 
            [Select 
                Id,
                RecordTypeId,
                Well_Event__r.Name
            From HOG_Service_Rig_Program__c
            Where Id = :serviceRigProgramId];

        System.debug('\n***************************************\n'
            + 'METHOD: createServiceRigWorkOrder()'
            + '\nrigProgramRecord: ' + rigProgramRecord
            + '\n***************************************\n');

        if (!rigProgramRecord.isEmpty())
        {                   
            // put the record id into a set and get the associated service request records
            Set<Id> setIds = new Set<Id>{notificationServicingFormId};
            
            // this will return 1 record or none 
            List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord = ServiceRequestNotificationUtilities.readServiceNotificationRequests(setIds);
                                
            If (!serviceRequestFormRecord.isEmpty())
            {               
                System.debug('\n***************************************\n'
                    + 'METHOD: createServiceRigWorkOrder()'
                    + '\nserviceRequestFormRecord: ' + serviceRequestFormRecord
                    + '\nserviceRequestFormRecord[0].Notification_Number__c: ' + serviceRequestFormRecord[0].Notification_Number__c
                    + '\n***************************************\n');

                if (!String.isBlank(serviceRequestFormRecord[0].Notification_Number__c))
                {               
                    if (serviceRequestFormRecord[0].SAP_Generated_Notification_Number__c)
                    {
                        List<Well_Tracker__c> wellTrackerRecord = 
                            [Select 
                                Id,
                                Number_Of_Work_Orders__c
                            From Well_Tracker__c
                            Where Id = :serviceRequestFormRecord[0].Well_Tracker__c];
    
                        HOG_Settings__c settingsHOG = HOG_Settings__c.getInstance();
                        
                        Integer lengthDescription = 
                            String.IsBlank(serviceRequestFormRecord[0].Work_Details__c)
                            ? 0
                            : serviceRequestFormRecord[0].Work_Details__c.length();
                                                
                        String mainDescription = 
                            String.IsBlank(serviceRequestFormRecord[0].Work_Details__c) 
                            ? '' 
                            : serviceRequestFormRecord[0].Work_Details__c.substring
                                (0, lengthDescription < ServiceRequestNotificationUtilities.LENGTHSAPMAINDESC 
                                    ? lengthDescription : ServiceRequestNotificationUtilities.LENGTHSAPMAINDESC);
                        
                        String mainLongDescription = serviceRequestFormRecord[0].Work_Details__c;                        
                        String equipmentNumber = serviceRequestFormRecord[0].Equipment__r.Equipment_Number__c;
                        
                        SAPHOGWorkOrderServices.WorkOrderPort workOrder = new SAPHOGWorkOrderServices.WorkOrderPort();
                        SAPHOGWorkOrderServices.CreateWorkOrderResponse response = new SAPHOGWorkOrderServices.CreateWorkOrderResponse();
            
                        try
                        {
                            if (Test.isRunningTest())
                            {
                                response.type_x = True;
                                response.WorkOrder = new SAPHOGWorkOrderServices.WorkOrder();
                            }
                            else
                            {
                                response = 
                                    workOrder.CreateWorkOrder
                                    (
                                         serviceRequestFormRecord[0].SAP_Object_ID__c, 
                                         serviceRequestFormRecord[0].Maintenance_Plant__c,
                                         mainDescription,
                                         mainLongDescription,
                                         serviceRequestFormRecord[0].HOG_Notification_Type_Priority_WO__r.Priority_Code__c,
                                         serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.Order_Type__c,
                                         serviceRequestFormRecord[0].Main_Work_Centre__c,
                                         serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.MAT_Code__c,
                                         settingsHOG.SAP_Create_Work_Order_Activity_Code__c,
                                         settingsHOG.SAP_Create_Work_Order_Control_Key__c,
                                         serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.HOG_User_Status__r.Code__c,
                                         serviceRequestFormRecord[0].Notification_Number__c,
                                         null,
                                         equipmentNumber
                                    );
                            }
                        }
                        catch(Exception e)
                        {
                            response = null;                                
                            System.debug('An unexpected error has occurred: ' + e.getMessage());
                            returnMessage = 'Service is not available because of the following error: ' + e.getMessage();
                        }           
                        
                        if (response != null)
                        {                                                                                                                                  
                            if (response.type_x)
                            {
                                Boolean updateNotificationRecord = String.isBlank(serviceRequestFormRecord[0].Work_Order_Number__c);
                                
                                serviceRequestFormRecord[0].Work_Order_Number__c = response.WorkOrder.WorkOrderNumber;                          
                                serviceRequestFormRecord[0].SAP_Generated_Work_Order_Number__c = true;
        
                                //  create the work order record in SF
                                ServiceRequestNotificationUtilities.ServiceRequest request = new ServiceRequestNotificationUtilities.ServiceRequest(); 
        
                                request.record = serviceRequestFormRecord[0];
                                request.workOrderName = rigProgramRecord[0].Well_Event__r.Name;
                                request.workOrderCount = 1;
                                request.workOrderSAPChangedDate = response.WorkOrder.ChangedDate;
                                request.workOrderSAPChangedBy = response.WorkOrder.ChangedBy;       
                                request.workOrderSystemStatusSAP = response.WorkOrder.SystemStatus;
                                request.workOrderUserStatusSAP = response.WorkOrder.UserStatus;
                                request.controlCentre = serviceRequestFormRecord[0].Well_Tracker__r.Control_Centre__c;
                                request.serviceTimeIsRequired = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Required__r.Vendor_Invoicing_Personnel_Is_Required__c;
                                request.vendorInvoicingPersonnelIsRequired = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Required__r.Service_Time_Is_Required__c;
                                
                                /*
                                request.mainWorkCentre = serviceRequestFormRecord[0].Main_Work_Centre__c;
                                request.businessUnit = serviceRequestFormRecord[0].Business_Unit_Lookup__c;
                                request.district = serviceRequestFormRecord[0].Operating_District_Lookup__c;
                                request.route = serviceRequestFormRecord[0].Operator_Route_Lookup__c;
                                request.field = serviceRequestFormRecord[0].Operating_Field_AMU_Lookup__c;      
                                request.facility = serviceRequestFormRecord[0].Facility_Lookup__c;
                                request.location = serviceRequestFormRecord[0].Location_Lookup__c;
                                */
                                
                                request.rigProgram = serviceRigProgramId;
                                request.notificationType = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__c;
                                                                
                                HOG_Maintenance_Servicing_Form__c riglessServicingForm = ServiceRequestNotificationUtilities.createServiceWorkOrder(request);                           
                                
                                if (riglessServicingForm != null)
                                {           
    
                                    ServiceRequestNotificationUtilities.executeTriggerCode = false;
                                    WellServicingUtilities.executeTriggerCode = false;
                                    MaintenanceServicingUtilities.executeTriggerCode = false;
    
                                    Savepoint savePoint = Database.setSavepoint();
                                    
                                    try
                                    {
                                        if (!wellTrackerRecord.isEmpty())
                                        {
                                            wellTrackerRecord[0].Number_Of_Work_Orders__c = 
                                                wellTrackerRecord[0].Number_Of_Work_Orders__c == null ? 1 : wellTrackerRecord[0].Number_Of_Work_Orders__c + 1;
                                                                
                                            update wellTrackerRecord;
                                        }
    
                                        if (updateNotificationRecord)
                                        {
                                            update serviceRequestFormRecord;
                                        }

                                        rigProgramRecord[0].RecordTypeId = serviceRigProgramRecordTypeId;                                       
                                        update rigProgramRecord;
                                        
                                        insert riglessServicingForm;
                                                                                                        
                                        returnMessage = '';
                                    }
                                    catch (System.DmlException e) 
                                    {                
                                        Database.rollback(savePoint);
                            
                                        System.debug('\n****************************************************************\n'
                                            + 'METHOD: ServiceNotificationRequestGlobal.createServiceRigWorkOrder()'
                                            + '\n***********************************************************************\n');
                            
                                        for (Integer i = 0; i < e.getNumDml(); i++)
                                            returnMessage = returnMessage + '\n' + e.getDmlMessage(i);
                                        
                                        System.debug(returnMessage);
                                    }                                                                                                                   
                                }
                            }
                            else
                            {
                                returnMessage = response.Message;
                            }
                        }
                    }
                    else
                    {
                        returnMessage = 'Service Request Notification number is not generated from SAP. Unable to create the work order number!';
                    }
                }
                else
                {
                    returnMessage = 'Service Request Notification number is empty. Unable to create the work order number!';
                }                                           
            }
            else
            {
                returnMessage = 'Service Request Notification does not exist. Unable to create the work order!';
            }
        }
        else
        {
            returnMessage = 'Rig Program record does not exist. Unable to create the work order!';
        }                       
        
        return returnMessage;
    }
    
    
   /********************************************************************************************************************
    * Calls the SAP Get WO web service, updates the work order, and returns the work order number or an error message
    * wellServicingFormId - The id of the Well Servicing Work Order record
    * notificationServicingFormId - The id of the Service Notification Request record
    * workOrderNumber - The work order number    
    * sapChangedDate - The last recorded "changed date" of SAP
    * sapChangedBy - The last recorded "changed by" of SAP
    ********************************************************************************************************************/    
    webservice static String updateServiceWorkOrderFromSAP
    (Id wellServicingFormId, Id notificationServicingFormId, String workOrderNumber)
    {
        System.debug('\n**********************************************************\n'
            + 'METHOD: ServiceNotificationRequestGlobal.updateServiceWorkOrderFromSAP()'
            + '\nwellServicingFormId: ' + wellServicingFormId
            + '\nworkOrderNumber: ' + workOrderNumber            
            + '\n*****************************************************************\n');

        String returnMessage = 'Service is down, please try again later...';

        // after passing all validations, call web service to get work order data
        SAPHOGWorkOrderServices.WorkOrderPort workOrder = new SAPHOGWorkOrderServices.WorkOrderPort();
        SAPHOGWorkOrderServices.GetWorkOrderResponse response = new SAPHOGWorkOrderServices.GetWorkOrderResponse();
        
        try
        {
            if (Test.isRunningTest())
            {
                response.type_x = True;
                response.WorkOrder = new SAPHOGWorkOrderServices.WorkOrder();
                response.WorkOrder.MaintenanceActivityType = 'TST';
            }
            else
                response = workOrder.GetWorkOrder(workOrderNumber);
        }
        catch(Exception e)
        {
            response = null;                                
            System.debug('An unexpected error has occurred: ' + e.getMessage());
            returnMessage = 'Service is not available because of the following error: ' + e.getMessage();
        }
                                        
        if (response != null)
        {                                    
            System.debug('SAPHOGWorkOrderServices.GetWorkOrderResponse response: ' + response);
            System.debug('response.WorkOrder.MainDescription: ' + response.WorkOrder.MainDescription);
            System.debug('response.WorkOrder.MainLongDescription: ' + response.WorkOrder.MainLongDescription);

            if (response.type_x)
            {               
                returnMessage = workOrderNumber;

                // this will return 1 record or none                
                List<HOG_Maintenance_Servicing_Form__c> wellServicingFormRecord = readServiceWorkOrders(wellServicingFormId);

                if (!wellServicingFormRecord.isEmpty())
                {               
                        // put the record id into a set and get the associated service request records
                        Set<Id> setIds = new Set<Id>{notificationServicingFormId};
                        
                        // this will return 1 record or none 
                        List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord = ServiceRequestNotificationUtilities.readServiceNotificationRequests(setIds);

                        If (!serviceRequestFormRecord.isEmpty())
                        {                                                                               
                            // compare Order Type between SF and SAP, if different then do not allow an update from SAP 
                            if (response.WorkOrder.OrderType == serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.Order_Type__c)
                            {                               
                                // compare MAT Code between SF and SAP, if different then do not allow an update from SAP 
                                if (response.WorkOrder.MaintenanceActivityType == serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.MAT_Code__c)
                                {                           
                                    String functionalLocationObjectId = serviceRequestFormRecord[0].SAP_Object_ID__c;
                                    
                                    // compare Functional Location between SF and SAP, if different then do not allow an update from SAP
                                    if (response.WorkOrder.FunctionalLocationObjectId == functionalLocationObjectId) 
                                    {
                                        HOG_Notification_Type_Priority__c priorityRecord = 
                                            readNotificationTypePriority(serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__c, response.WorkOrder.Priority, True);                           
                
                                        if (priorityRecord != null)
                                        {                                                                                                           
                                            wellServicingFormRecord[0].Main_Work_Centre__c = response.WorkOrder.MainWorkCenter;
                                            wellServicingFormRecord[0].Work_Details_Short__c = response.WorkOrder.MainDescription;
                                            wellServicingFormRecord[0].Work_Details__c = response.WorkOrder.MainLongDescription;
                                            wellServicingFormRecord[0].SAP_Changed_Date__c =  response.WorkOrder.ChangedDate;
                                            wellServicingFormRecord[0].SAP_Changed_By__c = response.WorkOrder.ChangedBy;
                                            wellServicingFormRecord[0].Notification_Number__c = response.WorkOrder.ReferenceNotificationNumber;
                                            wellServicingFormRecord[0].System_Status_Code__c = response.WorkOrder.SystemStatus;
                                            wellServicingFormRecord[0].User_Status_Code__c = response.WorkOrder.UserStatus;
                                            wellServicingFormRecord[0].TECO_Date_Completed__c = response.WorkOrder.TECODateCompleted;
                                            wellServicingFormRecord[0].TECO__c = response.WorkOrder.TECODateCompleted != null;
                                            wellServicingFormRecord[0].Request_Generate_Number_Message__c = null;
            
                                            serviceRequestFormRecord[0].HOG_Notification_Type_Priority_WO__c = priorityRecord.Id;
                                            serviceRequestFormRecord[0].Notification_Number__c = response.WorkOrder.ReferenceNotificationNumber;
                                            
                                            returnMessage = 
                                                wellServicingFormRecord[0].Recurring__c
                                                ? updateWorkOrderRecord(wellServicingFormRecord, workOrderNumber)
                                                : updateWorkOrderRecord(wellServicingFormRecord, serviceRequestFormRecord, workOrderNumber);        
                                        }       
                                        else
                                            returnMessage = 'SAP Work Order priority code ' + response.WorkOrder.Priority + ' is not configured in the system!';
                                    }
                                    else
                                        returnMessage = 'Functional Location has been changed in SAP. Refresh is not allowed!';                                 
                                        
                                }
                                else
                                    returnMessage = 'MAT code has been changed in SAP to ' + response.WorkOrder.MaintenanceActivityType + '. Refresh is not allowed!';
                            }
                            else
                                returnMessage = 'Order Type has been changed in SAP to ' + response.WorkOrder.OrderType + '. Refresh is not allowed!';
                        }
                        else
                            returnMessage = 'Service Request Notification does not exist. Unable to update the work order!';
                }
                else
                    returnMessage = 'Work Order does not exist. Unable to update the work order!';                                                 
            }
            else
                returnMessage = response.Message;                                                                      
        }
        return returnMessage;
    }


   /*********************************************************************************************************************
    * Calls the SAP Single Create NO web service, updates the work order, and returns an empty string or an error message
    * notificationServicingFormId - The id of the service notification request record
    *********************************************************************************************************************/    
    webservice static String createNoticationOrderInSAP(Id notificationServicingFormId)
    {
        System.debug('\n**************************************************************\n'
            + 'METHOD: ServiceNotificationRequestGlobal.createNoticationOrderInSAP()'
            + '\nnotificationServicingFormId: ' + notificationServicingFormId
            + '\n*********************************************************************\n');

        String returnMessage = 'Service is down, please try again later...';

//      List<HOG_Maintenance_Servicing_Form__c> wellServicingFormRecord = readServiceNotificationWorkOrders(notificationServicingFormId);

/*      
        if (wellServicingFormRecord != null && wellServicingFormRecord.size() > 0)
        {               
            if (wellServicingFormRecord[0].HOG_Notification_Type__r.Generate_Numbers_From_SAP__c) 
            {           
*/
                // put the record id into a set and get the associated service request records
                Set<Id> setIds = new Set<Id>{notificationServicingFormId};
                
                // this will return 1 record or none 
                List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord = ServiceRequestNotificationUtilities.readServiceNotificationRequests(setIds);

                System.debug('\n***************************************\n'
                    + 'METHOD: ServiceNotificationRequestGlobal.createNoticationOrderInSAP()'
                    + '\nserviceRequestFormRecord: ' + serviceRequestFormRecord
                    + '\n***************************************\n');
                        
                If (!serviceRequestFormRecord.isEmpty())
                {
                    if (serviceRequestFormRecord[0].UserRecordAccess.HasEditAccess)
                    {                    
                        //if (serviceRequestFormRecord[0].SAP_Generated_Notification_Number__c)
                        if (serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.Generate_Numbers_From_SAP__c)
                        {
                            String functionalLocationObjectId = serviceRequestFormRecord[0].SAP_Object_ID__c;
                            String maintenancePlanningPlant = serviceRequestFormRecord[0].Maintenance_Plant__c;                                                                                         
                            
                            Integer lengthDescription = 
                                String.IsBlank(serviceRequestFormRecord[0].Work_Details__c)
                                ? 0
                                : serviceRequestFormRecord[0].Work_Details__c.length();
                                                    
                            String mainDescription = 
                                String.IsBlank(serviceRequestFormRecord[0].Work_Details__c) 
                                ? '' 
                                : serviceRequestFormRecord[0].Work_Details__c.substring
                                    (0, lengthDescription < ServiceRequestNotificationUtilities.LENGTHSAPMAINDESC 
                                        ? lengthDescription : ServiceRequestNotificationUtilities.LENGTHSAPMAINDESC);
                            
                            String mainLongDescription = serviceRequestFormRecord[0].Work_Details__c;
                                                                    
                            String priority = serviceRequestFormRecord[0].HOG_Notification_Type_Priority__r.Priority_Code__c;
                            String notificationTypeCode = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.Notification_Type__c;
                            String maintenanceActivityType = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.MAT_Code__c;
                            //String notificationCodeGroup = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.HOG_Service_Code_Group__r.Code_Group__c;
                            String notificationCodeGroup = serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Required__r.HOG_Service_Code_Group__r.Code_Group__c;
                            
                            //String reportedBy = UserInfo.getLastName().toUpperCase() + ' ' + UserInfo.getFirstName().toUpperCase();                                               
                            String userName = String.isEmpty(UserInfo.getFirstName()) ? '' : UserInfo.getFirstName().toUpperCase();                     
                            String reportedBy = UserInfo.getLastName().toUpperCase() + ' ' + userName;
                            
                            String equipmentNumber = serviceRequestFormRecord[0].Equipment__r.Equipment_Number__c;
                            DateTime malfunctionStartDate = serviceRequestFormRecord[0].Malfunction_Start_Date__c;
                                    
                            //SM 1/22/16 we need to pass Equipment Down Indicator
                            String equipmentDown = MaintenanceServicingGlobal.GetEquipmentBreakDownIndicator(serviceRequestFormRecord[0].Equipment_Down__c);
                            SAPHOGNotificationServices.NotificationPort notification = new SAPHOGNotificationServices.NotificationPort();
                            SAPHOGNotificationServices.CreateNotificationResponse response = new SAPHOGNotificationServices.CreateNotificationResponse();
        
                            try
                            {
                                if (Test.isRunningTest())
                                {
                                    response.type_x = True;
                                    response.Notification = new SAPHOGNotificationServices.Notification();
                                }
                                else
                                {
                                    response =
                                        notification.CreateNotification
                                        (
                                            functionalLocationObjectId, 
                                            maintenancePlanningPlant, 
                                            mainDescription,
                                            mainLongDescription,            
                                            priority, 
                                            notificationTypeCode,
                                            null,
                                            maintenanceActivityType,
                                            notificationCodeGroup,
                                            reportedBy,
                                            equipmentNumber,
                                            malfunctionStartDate,
                                            null,
                                            equipmentDown
                                        );
                                }   
                            }
                            catch(Exception e)
                            {
                                response = null;                                
                                System.debug('An unexpected error has occurred: ' + e.getMessage());
                                returnMessage = 'Service is not available because of the following error: ' + e.getMessage();
                            }           
                                                                                                       
                            if (response != null)
                            {                                                                                                                                  
                                if (response.type_x)
                                {
                                    serviceRequestFormRecord[0].Work_Details_Short__c = mainDescription;
                                    serviceRequestFormRecord[0].SAP_Changed_Date__c = response.Notification.ChangedDate;
                                    serviceRequestFormRecord[0].SAP_Changed_By__c = response.Notification.ChangedBy;
                                    serviceRequestFormRecord[0].SAP_Generated_Notification_Number__c = true;
            
                                    //if wellServicingFormRecord[0].Recurring__c,  do not update Well Servicing WO, notification number for SNR and Well Servicing WO may be different
                                    //else update Well Servicing WO, notification number for SNR and Well Servicing WO is expected to be the same                       
                                    /*                              
                                    returnMessage =
                                        wellServicingFormRecord[0].Recurring__c 
                                        ? updateNotificationOrderRecord(serviceRequestFormRecord, response.Notification.NotificationNumber)
                                        : updateNotificationOrderRecord(serviceRequestFormRecord, wellServicingFormRecord, response.Notification.NotificationNumber);
                                    */
                                    
                                    List<HOG_Maintenance_Servicing_Form__c> wellServicingFormRecord = readServiceNotificationWorkOrders(notificationServicingFormId);
                                        
                                    returnMessage =
                                        serviceRequestFormRecord[0].Recurring_Start_Date__c != null || wellServicingFormRecord.IsEmpty()
                                        ? updateNotificationOrderRecord(serviceRequestFormRecord, response.Notification.NotificationNumber)
                                        : updateNotificationOrderRecord(serviceRequestFormRecord, wellServicingFormRecord, response.Notification.NotificationNumber);
                                                                                                            
                                    returnMessage = returnMessage != response.Notification.NotificationNumber ? returnMessage : '';
                                }
                                else
                                {
                                    returnMessage = response.Message;
                                }                                       
                            }
                        }
                        else
                        {
                            returnMessage = 'You are not allowed to create a Service Request Notification in SAP!';
                        }
                    }
                    else
                    {
                        returnMessage = 'You have no access to update this record!';                        
                    }                       
                }
                else
                {
                    returnMessage = 'Service Request Notification does not exist. Unable to update the notification number!';
                }

/*
            }
            else
                returnMessage = 'You are not allowed to create a Service Request Notification in SAP!';         
        }       
        else
            returnMessage = 'Work Order record does not exist. Unable to update the work order number!';                        
*/
        return returnMessage;
    }


    
   /*********************************************************************************************************************************
    * Calls the SAP Get NO web service, updates the notification order, and returns the notification order number or an error message
    * notificationServicingFormId - The id of the Service Notification Form
    * notificationOrderNumber - The notification order number
    *********************************************************************************************************************************/    
    webservice static String updateNotificationOrderFromSAP(Id notificationServicingFormId, String notificationOrderNumber)
    {
        System.debug('\n**********************************************************\n'
            + 'METHOD: ServiceNotificationRequestGlobal.updateNotificationOrderFromSAP()'
            + '\nnotificationServicingFormId: ' + notificationServicingFormId
            + '\nnotificationOrderNumber: ' + notificationOrderNumber
            + '\n*****************************************************************\n');

        String returnMessage = 'Service is down, please try again later...';

        // put the record id into a set and get the associated service request records
        Set<Id> setIds = new Set<Id>{notificationServicingFormId};
                            
        // this will return 1 record or none 
        List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord = ServiceRequestNotificationUtilities.readServiceNotificationRequests(setIds);
        
        If (!serviceRequestFormRecord.isEmpty())
        {                                                     
            if (serviceRequestFormRecord[0].UserRecordAccess.HasEditAccess)
            {                    

                // after passing all validations, call web service to get work order data
                SAPHOGNotificationServices.NotificationPort notificationOrder = new SAPHOGNotificationServices.NotificationPort();
                SAPHOGNotificationServices.GetNotificationResponse response = new SAPHOGNotificationServices.GetNotificationResponse();
        
                try
                {
                    
                    if (Test.isRunningTest())
                    {
                        System.debug('debug_isTestRespType: ' + isTestRespType);
                        
                        if (isTestRespType == 'wellLocation'){
                            response.type_x = True;
                            response.Notification = new SAPHOGNotificationServices.Notification();
                            response.Notification.Coding = 'TST';
                            response.Notification.EquipmentNumber = '12345678';
                            response.Notification.FunctionalLocationObjectId = '?012345'; 
                        }
                        
                        else if (isTestRespType == 'facility'){
                            response.type_x = True;
                            response.Notification = new SAPHOGNotificationServices.Notification();
                            response.Notification.Coding = 'TST';
                            response.Notification.NotificationNumber = '0000001';
                            response.Notification.FunctionalLocationObjectId = '?000001';
                        }
                        
                        else if (isTestRespType == 'system'){
                            response.type_x = True;
                            response.Notification = new SAPHOGNotificationServices.Notification();
                            response.Notification.Coding = 'TST';
                            response.Notification.NotificationNumber = '0000002';
                            response.Notification.FunctionalLocationObjectId = '?000002';
                        }
                        
                        else if (isTestRespType == 'sub-system'){
                            response.type_x = True;
                            response.Notification = new SAPHOGNotificationServices.Notification();
                            response.Notification.Coding = 'TST';
                            response.Notification.NotificationNumber = '0000003';
                            response.Notification.FunctionalLocationObjectId = '?000003';
                        }
                        else if (isTestRespType == 'wellEvent'){
                            response.type_x = True;
                            response.Notification = new SAPHOGNotificationServices.Notification();
                            response.Notification.Coding = 'TST';
                            response.Notification.NotificationNumber = '0000004';
                            response.Notification.FunctionalLocationObjectId = '?000004';
                        }
                        else if (isTestRespType == 'yard'){
                            response.type_x = True;
                            response.Notification = new SAPHOGNotificationServices.Notification();
                            response.Notification.Coding = 'TST';
                            response.Notification.NotificationNumber = '0000005';
                            response.Notification.FunctionalLocationObjectId = '?000005';
                        }
                        else if (isTestRespType == 'fel'){
                            response.type_x = True;
                            response.Notification = new SAPHOGNotificationServices.Notification();
                            response.Notification.Coding = 'TST';
                            response.Notification.NotificationNumber = '0000006';
                            response.Notification.FunctionalLocationObjectId = '?000006';
                        }
                    }
                    else
                        response = notificationOrder.GetNotification(notificationOrderNumber);
                }
                catch(Exception e)
                {
                    response = null;                                
                    System.debug('An unexpected error has occurred: ' + e.getMessage());
                    returnMessage = 'Service is not available because of the following error: ' + e.getMessage();
                }
                                                
                if (response != null)
                {                                    
                    System.debug('SAPHOGNotificationServices.GetNotificationResponse response: ' + response);
                    System.debug('response.Notification.MainDescription: ' + response.Notification.MainDescription);
                    System.debug('response.Notification.MainLongDescription: ' + response.Notification.MainLongDescription);

                    if (response.type_x)
                    {
                        returnMessage = response.Notification.NotificationNumber;
        
                        if (serviceRequestFormRecord[0].SAP_Changed_Date__c != response.Notification.ChangedDate || 
                        serviceRequestFormRecord[0].SAP_Changed_By__c != response.Notification.ChangedBy)
                        {                               
                            if (response.Notification.NotificationType == serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__r.Notification_Type__c) 
                            {
                                //handling for correct FLOC object needs to be implemented here
                                Equipment__c equipment = ServiceRequestNotificationUtilities.getEquipment(response.Notification.EquipmentNumber);
                                Location__c wellLocation = ServiceRequestNotificationUtilities.getLocation(response.Notification.FunctionalLocationObjectId);
                                Facility__c facility = ServiceRequestNotificationUtilities.getFacility(response.Notification.FunctionalLocationObjectId);
                                Well_Event__c wellEvent = ServiceRequestNotificationUtilities.getWellEvent(response.Notification.FunctionalLocationObjectId);
                                System__c sys = ServiceRequestNotificationUtilities.getSystem(response.Notification.FunctionalLocationObjectId);
                                Sub_System__c subSys = ServiceRequestNotificationUtilities.getSubSystem(response.Notification.FunctionalLocationObjectId);
                                Functional_Equipment_Level__c fel = ServiceRequestNotificationUtilities.getFunctionalEquipmentLevel(response.Notification.FunctionalLocationObjectId);
                                Yard__c yard = ServiceRequestNotificationUtilities.getYard(response.Notification.FunctionalLocationObjectId);

                                // Init Util class
                                ServiceRequestNotificationUtilities.NotificationRecordType notificationRecordType = new ServiceRequestNotificationUtilities.NotificationRecordType();
                                
                                System.Debug('debug_response.Notification.EquipmentNumber: ' + response.Notification.EquipmentNumber);
                                     
                                if (equipment != null && wellLocation != null && equipment.Functional_Location__c != wellLocation.Functional_Location_Description_SAP__c) {
                                        
                                    returnMessage = 'Equipment number does not match the Functional Location for the Well Location specified!';   
                                }
  
                                else if (equipment != null && sys != null && equipment.Functional_Location__c != sys.Functional_Location_Description_SAP__c) {
                                
                                    returnMessage = 'Equipment number does not match the Functional Location for the System specified!';   
                                }
                                
                                else if (equipment != null && subSys != null && equipment.Functional_Location__c != subSys.Functional_Location_Description_SAP__c) {
                                        
                                    returnMessage = 'Equipment number does not match the Functional Location for the Sub-System specified!';   
                                }

                                else if (equipment != null && fel != null && equipment.Functional_Location__c != fel.Functional_Location_Description_SAP__c) {
                                        
                                    returnMessage = 'Equipment number does not match the Functional Location for the Functional Equipment Level specified!';   
                                }

                                else if (equipment != null && yard != null && equipment.Functional_Location__c != yard.Functional_Location_Description_SAP__c) {
                                        
                                    returnMessage = 'Equipment number does not match the Functional Location for the Yard specified!';   
                                }
                                
                                else if (equipment != null && wellEvent != null && equipment.Functional_Location__c != wellEvent.Functional_Location_Description_SAP__c){
                                    
                                    returnMessage = 'Equipment number does not match the Functional Location for the Well Event specified!';      
                                
                                } else {

                                    if (response.Notification.Coding == serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.MAT_Code__c) {
                                        if (response.Notification.CodingGroup == serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Service_Required__r.HOG_Service_Code_Group__r.Code_Group__c) {
                                            HOG_Notification_Type_Priority__c priorityRecord = 
                                                readNotificationTypePriority(serviceRequestFormRecord[0].HOG_Work_Order_Type__r.HOG_Notification_Type__c, response.Notification.Priority, False);                           
                        
                                            if (priorityRecord != null)
                                            {                                                                           
                                                serviceRequestFormRecord[0].Work_Details_Short__c = response.Notification.MainDescription;
                                                serviceRequestFormRecord[0].Work_Details__c = response.Notification.MainLongDescription;
                                                serviceRequestFormRecord[0].SAP_Changed_Date__c =  response.Notification.ChangedDate;
                                                serviceRequestFormRecord[0].SAP_Changed_By__c = response.Notification.ChangedBy;
                                                serviceRequestFormRecord[0].HOG_Notification_Type_Priority__c = priorityRecord.Id;
                                                serviceRequestFormRecord[0].Main_Work_Centre__c = response.Notification.MainWorkCenter;
                                                serviceRequestFormRecord[0].Maintenance_Plant__c = response.Notification.MaintenancePlanningPlant;
                                                //ssd - W-000352 new fields being refreshed
                                                serviceRequestFormRecord[0].Malfunction_Start_Date__c = response.Notification.MalfunctionStartDate;
                                                serviceRequestFormRecord[0].Malfunction_End_Date__c = response.Notification.MalfunctionEndDate;
                                                
                                                //mz - updated logic for system & sub-system
                                                serviceRequestFormRecord[0].Equipment__c = (equipment == null) ? null : equipment.Id;
                                                serviceRequestFormRecord[0].RecordTypeId = (equipment != null) ? ServiceRequestNotificationUtilities.readObjectRecordTypeId(
                                                                                    notificationRecordType.NOTIFICATIONOBJECTNAME, notificationRecordType.EQUIPMENT) :
                                                                                    serviceRequestFormRecord[0].RecordTypeId;   

                                                if (wellLocation != null){
                                                    
                                                    if(wellLocation.RecordType.Name.equals(notificationRecordType.WELL)){
                                                        serviceRequestFormRecord[0].RecordTypeId = (equipment == null) ? ServiceRequestNotificationUtilities.readObjectRecordTypeId(
                                                                                    notificationRecordType.NOTIFICATIONOBJECTNAME, notificationRecordType.WELL) :
                                                                                    serviceRequestFormRecord[0].RecordTypeId;
                                                    } 

                                                    serviceRequestFormRecord[0].Location_Lookup__c =   wellLocation.Id;
                                                    serviceRequestFormRecord[0].Facility_Lookup__c = null;
                                                    serviceRequestFormRecord[0].System__c = null;
                                                    serviceRequestFormRecord[0].Sub_System__c = null;
                                                    serviceRequestFormRecord[0].Well_Event__c = null;
                                                    serviceRequestFormRecord[0].Functional_Equipment_Level__c = null;
                                                    serviceRequestFormRecord[0].Yard__c = null;
                                                }
                                                
                                                else if (facility != null){
                                                    serviceRequestFormRecord[0].RecordTypeId = (equipment == null) ? ServiceRequestNotificationUtilities.readObjectRecordTypeId(
                                                                                    notificationRecordType.NOTIFICATIONOBJECTNAME, notificationRecordType.FACILITY) :
                                                                                    serviceRequestFormRecord[0].RecordTypeId;  

                                                    serviceRequestFormRecord[0].Facility_Lookup__c = facility.Id;
                                                    serviceRequestFormRecord[0].Location_Lookup__c =  null;
                                                    serviceRequestFormRecord[0].System__c = null;
                                                    serviceRequestFormRecord[0].Sub_System__c = null;
                                                    serviceRequestFormRecord[0].Well_Event__c = null;
                                                    serviceRequestFormRecord[0].Functional_Equipment_Level__c = null;
                                                    serviceRequestFormRecord[0].Yard__c = null;
                                                }
                                                
                                                else if (sys != null){
                                                    serviceRequestFormRecord[0].RecordTypeId = (equipment == null) ? ServiceRequestNotificationUtilities.readObjectRecordTypeId(
                                                                                    notificationRecordType.NOTIFICATIONOBJECTNAME, notificationRecordType.MAINSYSTEM) :
                                                                                    serviceRequestFormRecord[0].RecordTypeId;  

                                                    serviceRequestFormRecord[0].System__c = sys.Id;
                                                    serviceRequestFormRecord[0].Location_Lookup__c =  null;
                                                    serviceRequestFormRecord[0].Facility_Lookup__c = null;
                                                    serviceRequestFormRecord[0].Sub_System__c = null;
                                                    serviceRequestFormRecord[0].Well_Event__c = null;
                                                    serviceRequestFormRecord[0].Functional_Equipment_Level__c = null;
                                                    serviceRequestFormRecord[0].Yard__c = null;
                                                }
                                                
                                                else if (subSys != null){
                                                    serviceRequestFormRecord[0].RecordTypeId = (equipment == null) ? ServiceRequestNotificationUtilities.readObjectRecordTypeId(
                                                                                    notificationRecordType.NOTIFICATIONOBJECTNAME, notificationRecordType.SUBSYSTEM) :
                                                                                    serviceRequestFormRecord[0].RecordTypeId;  
                                                    
                                                    serviceRequestFormRecord[0].Sub_System__c = subSys.Id;
                                                    serviceRequestFormRecord[0].Location_Lookup__c =  null;
                                                    serviceRequestFormRecord[0].Facility_Lookup__c = null;
                                                    serviceRequestFormRecord[0].System__c = null;
                                                    serviceRequestFormRecord[0].Well_Event__c = null;
                                                    serviceRequestFormRecord[0].Functional_Equipment_Level__c = null;
                                                    serviceRequestFormRecord[0].Yard__c = null;
                                                }
                                                
                                                else if (wellEvent != null){
                                                    serviceRequestFormRecord[0].RecordTypeId = (equipment == null) ? ServiceRequestNotificationUtilities.readObjectRecordTypeId(
                                                                                    notificationRecordType.NOTIFICATIONOBJECTNAME, notificationRecordType.WELLEVENT) :
                                                                                    serviceRequestFormRecord[0].RecordTypeId;  

                                                    serviceRequestFormRecord[0].Well_Event__c = wellEvent.Id;
                                                    serviceRequestFormRecord[0].Location_Lookup__c =  null;
                                                    serviceRequestFormRecord[0].Facility_Lookup__c = null;
                                                    serviceRequestFormRecord[0].System__c = null;
                                                    serviceRequestFormRecord[0].Sub_System__c = null;
                                                    serviceRequestFormRecord[0].Functional_Equipment_Level__c = null;
                                                    serviceRequestFormRecord[0].Yard__c = null;
                                                }

                                                else if (fel != null){
                                                    serviceRequestFormRecord[0].RecordTypeId = (equipment == null) ? ServiceRequestNotificationUtilities.readObjectRecordTypeId(
                                                                                    notificationRecordType.NOTIFICATIONOBJECTNAME, notificationRecordType.FUNCTIONALEQUIPMENT) :
                                                                                    serviceRequestFormRecord[0].RecordTypeId;

                                                    serviceRequestFormRecord[0].Well_Event__c = null;
                                                    serviceRequestFormRecord[0].Location_Lookup__c =  null;
                                                    serviceRequestFormRecord[0].Facility_Lookup__c = null;
                                                    serviceRequestFormRecord[0].System__c = null;
                                                    serviceRequestFormRecord[0].Sub_System__c = null;
                                                    serviceRequestFormRecord[0].Functional_Equipment_Level__c = fel.Id;
                                                    serviceRequestFormRecord[0].Yard__c = null;
                                                }

                                                else if (yard != null){
                                                    serviceRequestFormRecord[0].RecordTypeId = (equipment == null) ? ServiceRequestNotificationUtilities.readObjectRecordTypeId(
                                                                                    notificationRecordType.NOTIFICATIONOBJECTNAME, notificationRecordType.YARD) :
                                                                                    serviceRequestFormRecord[0].RecordTypeId;

                                                    serviceRequestFormRecord[0].Well_Event__c = null;
                                                    serviceRequestFormRecord[0].Location_Lookup__c =  null;
                                                    serviceRequestFormRecord[0].Facility_Lookup__c = null;
                                                    serviceRequestFormRecord[0].System__c = null;
                                                    serviceRequestFormRecord[0].Sub_System__c = null;
                                                    serviceRequestFormRecord[0].Functional_Equipment_Level__c = yard.id;
                                                    serviceRequestFormRecord[0].Yard__c = null;
                                                }
                                                
                                                
                                                returnMessage = updateNotificationOrderRecord(serviceRequestFormRecord, notificationOrderNumber);
                                            } else
                                                returnMessage = 'SAP Notification Order priority code ' + response.Notification.Priority + ' is not configured in the system!';
                                        } else
                                            returnMessage = 'Notification Coding Group has been changed in SAP. Refresh is not allowed!';                                       
                                    } else
                                        returnMessage = 'Notification MAT code has been changed in SAP. Refresh is not allowed!';
                                }
                            }
                            else
                                returnMessage = 'Notification Type has been changed in SAP to ' + response.Notification.NotificationType + '. Refresh is not allowed!';                         
                        }
                    }
                    else
                        returnMessage = response.Message;                                                                      
                }
            }
            else
                returnMessage = 'You have no access to update this record!';
        }
        else
            returnMessage = 'Service Request Notification does not exist. Unable to update the work order!';
        
        return returnMessage;
    }    


   /****************************************************************************************************************************************
    * Updates the service notification request record and well servicing record, returns the updated notification number or an error message
    * serviceRequestFormRecord - The Service Notification Request record to be updated
    * wellServicingFormRecord - The Well Servicing Work Order record to be updated
    * notificationNumber - The notification number
    ****************************************************************************************************************************************/
    @TestVisible        
    private static String updateNotificationOrderRecord
    (
        List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord, 
        List<HOG_Maintenance_Servicing_Form__c> wellServicingFormRecord, 
        String notificationNumber
    )
    {
        Integer updatedWellServicingFormRecord = 0;
        String returnMessage = 'You are not allowed to update the notification number!';
                                
        for (HOG_Maintenance_Servicing_Form__c record : wellServicingFormRecord)
        {
            record.Notification_Number__c = notificationNumber;
            record.SAP_Generated_Notification_Number__c = true;            
            record.Request_Generate_Number_Message__c = null;            
            updatedWellServicingFormRecord++;
        }
        
        if (updatedWellServicingFormRecord > 0)
        {
            ServiceRequestNotificationUtilities.executeTriggerCode = false;
            WellServicingUtilities.executeTriggerCode = false;
            MaintenanceServicingUtilities.executeTriggerCode = false;

            Savepoint savePoint = Database.setSavepoint();
    
            try 
            {
                update wellServicingFormRecord;        
                update serviceRequestFormRecord;
                returnMessage = notificationNumber;
            }
            catch (System.DmlException e) 
            {                
                Database.rollback(savePoint);
    
                System.debug('\n****************************************************************\n'
                    + 'METHOD: ServiceNotificationRequestGlobal.updateNotificationOrderRecord()'
                    + '\n***********************************************************************\n');
    
                for (Integer i = 0; i < e.getNumDml(); i++)
                    returnMessage = returnMessage + '\n' + e.getDmlMessage(i);
                
                System.debug(returnMessage);                    
            }                                                                                    
        }
                
        return returnMessage;
    }


   /****************************************************************************************************************************
    * Updates the service notification request record and returns the updated notification number or an error message
    * serviceRequestFormRecord - The Service Notification Request record to be updated
    * notificationNumber - The notification number
    ****************************************************************************************************************************/
    @TestVisible        
    private static String updateNotificationOrderRecord
    (List<HOG_Service_Request_Notification_Form__c> serviceRequestFormRecord, String notificationNumber)
    {
        String returnMessage = 'You are not allowed to update the notification number!';

        ServiceRequestNotificationUtilities.executeTriggerCode = false;
        WellServicingUtilities.executeTriggerCode = false;
        MaintenanceServicingUtilities.executeTriggerCode = false;

        Savepoint savePoint = Database.setSavepoint();

        try 
        {
            update serviceRequestFormRecord;
            returnMessage = notificationNumber;
        }
        catch (System.DmlException e) 
        {                
            Database.rollback(savePoint);

            System.debug('\n********************************************************\n'
                + 'METHOD: ServiceNotificationRequestGlobal.updateWorkOrderNumber()'
                + '\n***************************************************************\n');

            for (Integer i = 0; i < e.getNumDml(); i++)
                returnMessage = returnMessage + '\n' + e.getDmlMessage(i);
                
            System.debug(returnMessage);              
        }                                                                                    
                        
        return returnMessage;
    }


   /*************************************************************************************************************************
    * Returns a single Notification Priority record given the notification type id, priority code and priority type indicator 
    * notificationTypeId - The notification type id
    * priorityCode - The notification priority code
    * workOrderPriorityType - Find the the work order priority, otherwise the notification priority
    ************************************************************************************************************************/    
    @TestVisible 
    private static HOG_Notification_Type_Priority__c readNotificationTypePriority
    (
        Id notificationTypeId,
        String priorityCode,
        Boolean workOrderPriorityType
    )
    {
        List<HOG_Notification_Type_Priority__c> priorityRecord =
            [Select
                    Id,
                    HOG_Notification_Type__c,
                    HOG_Service_Priority__r.Priority_Code__c
                From HOG_Notification_Type_Priority__c
                Where 
                    HOG_Notification_Type__c = :notificationTypeId
                    And Work_Order_Priority__c = :workOrderPriorityType
                    And HOG_Service_Priority__r.Priority_Code__c = :priorityCode
                Limit 1
            ];
        
        return priorityRecord != null && priorityRecord.size() > 0 ? priorityRecord[0] : null;            
    }
    
    
    /*****************************************************************************************************
     * Returns a list of work orders associated to a notification
     * notificationId - The notification id to retrieve
     *****************************************************************************************************/
    @TestVisible     
    private static List<HOG_Maintenance_Servicing_Form__c> readServiceNotificationWorkOrders(Id notificationId)
    {
        return 
            [Select
                Id,
                Name,
                Facility__r.Name,
                Location__r.Name,
                Work_Order_Number__c,
                Notification_Number__c,
                Work_Details__c,
                Recurring__c,
                Request_Generate_Number_Message__c,
                HOG_Notification_Type__r.Generate_Numbers_From_SAP__c                           
            From HOG_Maintenance_Servicing_Form__c
            Where HOG_Service_Request_Notification_Form__c = :notificationId]; 
    }


    /*****************************************************************************************************
     * Returns a list of work orders associated to a work order
     * workOrderId - The work order id to retrieve
     *****************************************************************************************************/
    @TestVisible     
    private static List<HOG_Maintenance_Servicing_Form__c> readServiceWorkOrders(Id workOrderId)
    {
        return 
            [Select
                Id,
                Name,
                Facility__r.Name,
                Location__r.Name,
                Equipment__c,
                Equipment__r.Equipment_Number__c,
                Work_Order_Number__c,
                Notification_Number__c,
                HOG_Service_Request_Notification_Form__c,
                SAP_Changed_Date__c,
                SAP_Changed_By__c,
                System_Status_Code__c,
                User_Status_Code__c,                
                Main_Work_Centre__c,
                Work_Details_Short__c,
                Work_Details__c,
                Request_Generate_Number_Message__c,
                SAP_Generated_Work_Order_Number__c,
                Recurring__c,
                TECO_Date_Completed__c,
                TECO__c,
                SAP_Request_Returned_Critical_Error__c,
                Service_Status__c,
                HOG_Notification_Type__r.Generate_Numbers_From_SAP__c,
                HOG_Notification_Type__r.Allow_Manual_Update_Of_Work_Order_Number__c
            From HOG_Maintenance_Servicing_Form__c
            Where Id = :workOrderId]; 
    }    
}